function Hd = elliptic
%ELLIPTIC Returns a discrete-time filter object.

% MATLAB Code
% Generated by MATLAB(R) 23.2 and Signal Processing Toolbox 23.2.
% Generated on: 27-Mar-2024 18:58:12

% Elliptic Bandstop filter designed using FDESIGN.BANDSTOP.

% All frequency values are in Hz.
Fs = 44100;  % Sampling Frequency

Fpass1 = 6300;    % First Passband Frequency
Fstop1 = 7350;    % First Stopband Frequency
Fstop2 = 14700;   % Second Stopband Frequency
Fpass2 = 17640;   % Second Passband Frequency
Apass1 = 1;       % First Passband Ripple (dB)
Astop  = 50;      % Stopband Attenuation (dB)
Apass2 = 1;       % Second Passband Ripple (dB)
match  = 'both';  % Band to match exactly

% Construct an FDESIGN object and call its ELLIP method.
h  = fdesign.bandstop(Fpass1, Fstop1, Fstop2, Fpass2, Apass1, Astop, ...
                      Apass2, Fs);
Hd = design(h, 'ellip', 'MatchExactly', match);

% [EOF]
